// Copyright 2018 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "third_party/blink/renderer/modules/webgpu/webgpu_device.h"

#include "third_party/blink/renderer/modules/webgpu/webgpu_adapter.h"

namespace blink {

// static
WebGPUDevice* WebGPUDevice::Create(WebGPUAdapter* adapter) {
  return new WebGPUDevice(adapter);
}

WebGPUAdapter* WebGPUDevice::adapter() const {
  return adapter_;
}

void WebGPUDevice::Trace(blink::Visitor* visitor) {
  visitor->Trace(adapter_);
  ScriptWrappable::Trace(visitor);
}

WebGPUDevice::WebGPUDevice(WebGPUAdapter* adapter) : adapter_(adapter) {}

}  // namespace blink
