// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "third_party/blink/renderer/bindings/core/v8/v8_request_init.h"

#include "base/stl_util.h"
#include "third_party/blink/renderer/bindings/core/v8/idl_types.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/core/v8/script_value.h"
#include "third_party/blink/renderer/bindings/core/v8/v8_abort_signal.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"
#include "third_party/blink/renderer/platform/runtime_enabled_features.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8RequestInitKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "body",
    "cache",
    "credentials",
    "headers",
    "importance",
    "integrity",
    "keepalive",
    "method",
    "mode",
    "redirect",
    "referrer",
    "referrerPolicy",
    "signal",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, base::size(kKeys));
}

void V8RequestInit::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, RequestInit& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8RequestInitKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> bodyValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&bodyValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (bodyValue.IsEmpty() || bodyValue->IsUndefined()) {
    // Do nothing.
  } else {
    ScriptValue bodyCppValue = ScriptValue(ScriptState::Current(isolate), bodyValue);
    impl.setBody(bodyCppValue);
  }

  v8::Local<v8::Value> cacheValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&cacheValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (cacheValue.IsEmpty() || cacheValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> cacheCppValue = cacheValue;
    if (!cacheCppValue.Prepare(exceptionState))
      return;
    const char* validValues[] = {
        "default",
        "no-store",
        "reload",
        "no-cache",
        "force-cache",
        "only-if-cached",
    };
    if (!IsValidEnum(cacheCppValue, validValues, base::size(validValues), "RequestCache", exceptionState))
      return;
    impl.setCache(cacheCppValue);
  }

  v8::Local<v8::Value> credentialsValue;
  if (!v8Object->Get(context, keys[2].Get(isolate)).ToLocal(&credentialsValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (credentialsValue.IsEmpty() || credentialsValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> credentialsCppValue = credentialsValue;
    if (!credentialsCppValue.Prepare(exceptionState))
      return;
    const char* validValues[] = {
        "omit",
        "same-origin",
        "include",
    };
    if (!IsValidEnum(credentialsCppValue, validValues, base::size(validValues), "RequestCredentials", exceptionState))
      return;
    impl.setCredentials(credentialsCppValue);
  }

  v8::Local<v8::Value> headersValue;
  if (!v8Object->Get(context, keys[3].Get(isolate)).ToLocal(&headersValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (headersValue.IsEmpty() || headersValue->IsUndefined()) {
    // Do nothing.
  } else {
    ByteStringSequenceSequenceOrByteStringByteStringRecord headersCppValue;
    V8ByteStringSequenceSequenceOrByteStringByteStringRecord::ToImpl(isolate, headersValue, headersCppValue, UnionTypeConversionMode::kNotNullable, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setHeaders(headersCppValue);
  }

  v8::Local<v8::Value> integrityValue;
  if (!v8Object->Get(context, keys[5].Get(isolate)).ToLocal(&integrityValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (integrityValue.IsEmpty() || integrityValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> integrityCppValue = integrityValue;
    if (!integrityCppValue.Prepare(exceptionState))
      return;
    impl.setIntegrity(integrityCppValue);
  }

  v8::Local<v8::Value> keepaliveValue;
  if (!v8Object->Get(context, keys[6].Get(isolate)).ToLocal(&keepaliveValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (keepaliveValue.IsEmpty() || keepaliveValue->IsUndefined()) {
    // Do nothing.
  } else {
    bool keepaliveCppValue = NativeValueTraits<IDLBoolean>::NativeValue(isolate, keepaliveValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setKeepalive(keepaliveCppValue);
  }

  v8::Local<v8::Value> methodValue;
  if (!v8Object->Get(context, keys[7].Get(isolate)).ToLocal(&methodValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (methodValue.IsEmpty() || methodValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> methodCppValue = NativeValueTraits<IDLByteString>::NativeValue(isolate, methodValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setMethod(methodCppValue);
  }

  v8::Local<v8::Value> modeValue;
  if (!v8Object->Get(context, keys[8].Get(isolate)).ToLocal(&modeValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (modeValue.IsEmpty() || modeValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> modeCppValue = modeValue;
    if (!modeCppValue.Prepare(exceptionState))
      return;
    const char* validValues[] = {
        "navigate",
        "same-origin",
        "no-cors",
        "cors",
    };
    if (!IsValidEnum(modeCppValue, validValues, base::size(validValues), "RequestMode", exceptionState))
      return;
    impl.setMode(modeCppValue);
  }

  v8::Local<v8::Value> redirectValue;
  if (!v8Object->Get(context, keys[9].Get(isolate)).ToLocal(&redirectValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (redirectValue.IsEmpty() || redirectValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> redirectCppValue = redirectValue;
    if (!redirectCppValue.Prepare(exceptionState))
      return;
    const char* validValues[] = {
        "follow",
        "error",
        "manual",
    };
    if (!IsValidEnum(redirectCppValue, validValues, base::size(validValues), "RequestRedirect", exceptionState))
      return;
    impl.setRedirect(redirectCppValue);
  }

  v8::Local<v8::Value> referrerValue;
  if (!v8Object->Get(context, keys[10].Get(isolate)).ToLocal(&referrerValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (referrerValue.IsEmpty() || referrerValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> referrerCppValue = NativeValueTraits<IDLUSVString>::NativeValue(isolate, referrerValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setReferrer(referrerCppValue);
  }

  v8::Local<v8::Value> referrerPolicyValue;
  if (!v8Object->Get(context, keys[11].Get(isolate)).ToLocal(&referrerPolicyValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (referrerPolicyValue.IsEmpty() || referrerPolicyValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> referrerPolicyCppValue = referrerPolicyValue;
    if (!referrerPolicyCppValue.Prepare(exceptionState))
      return;
    const char* validValues[] = {
        "",
        "no-referrer",
        "no-referrer-when-downgrade",
        "same-origin",
        "origin",
        "strict-origin",
        "origin-when-cross-origin",
        "strict-origin-when-cross-origin",
        "unsafe-url",
    };
    if (!IsValidEnum(referrerPolicyCppValue, validValues, base::size(validValues), "ReferrerPolicy", exceptionState))
      return;
    impl.setReferrerPolicy(referrerPolicyCppValue);
  }

  v8::Local<v8::Value> signalValue;
  if (!v8Object->Get(context, keys[12].Get(isolate)).ToLocal(&signalValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (signalValue.IsEmpty() || signalValue->IsUndefined()) {
    // Do nothing.
  } else if (signalValue->IsNull()) {
    impl.setSignalToNull();
  } else {
    AbortSignal* signalCppValue = V8AbortSignal::ToImplWithTypeCheck(isolate, signalValue);
    if (!signalCppValue) {
      exceptionState.ThrowTypeError("member signal is not of type AbortSignal.");
      return;
    }
    impl.setSignal(signalCppValue);
  }

  if (RuntimeEnabledFeatures::PriorityHintsEnabled()) {
    v8::Local<v8::Value> importanceValue;
    if (!v8Object->Get(context, keys[4].Get(isolate)).ToLocal(&importanceValue)) {
      exceptionState.RethrowV8Exception(block.Exception());
      return;
    }
    if (importanceValue.IsEmpty() || importanceValue->IsUndefined()) {
      // Do nothing.
    } else {
      V8StringResource<> importanceCppValue = importanceValue;
      if (!importanceCppValue.Prepare(exceptionState))
        return;
      const char* validValues[] = {
          "low",
          "auto",
          "high",
      };
      if (!IsValidEnum(importanceCppValue, validValues, base::size(validValues), "RequestImportance", exceptionState))
        return;
      impl.setImportance(importanceCppValue);
    }
  }
}

v8::Local<v8::Value> RequestInit::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8RequestInit(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8RequestInit(const RequestInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8RequestInitKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> bodyValue;
  bool bodyHasValueOrDefault = false;
  if (impl.hasBody()) {
    bodyValue = impl.body().V8Value();
    bodyHasValueOrDefault = true;
  }
  if (bodyHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), bodyValue))) {
    return false;
  }

  v8::Local<v8::Value> cacheValue;
  bool cacheHasValueOrDefault = false;
  if (impl.hasCache()) {
    cacheValue = V8String(isolate, impl.cache());
    cacheHasValueOrDefault = true;
  }
  if (cacheHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), cacheValue))) {
    return false;
  }

  v8::Local<v8::Value> credentialsValue;
  bool credentialsHasValueOrDefault = false;
  if (impl.hasCredentials()) {
    credentialsValue = V8String(isolate, impl.credentials());
    credentialsHasValueOrDefault = true;
  }
  if (credentialsHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[2].Get(isolate), credentialsValue))) {
    return false;
  }

  v8::Local<v8::Value> headersValue;
  bool headersHasValueOrDefault = false;
  if (impl.hasHeaders()) {
    headersValue = ToV8(impl.headers(), creationContext, isolate);
    headersHasValueOrDefault = true;
  }
  if (headersHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[3].Get(isolate), headersValue))) {
    return false;
  }

  v8::Local<v8::Value> integrityValue;
  bool integrityHasValueOrDefault = false;
  if (impl.hasIntegrity()) {
    integrityValue = V8String(isolate, impl.integrity());
    integrityHasValueOrDefault = true;
  }
  if (integrityHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[5].Get(isolate), integrityValue))) {
    return false;
  }

  v8::Local<v8::Value> keepaliveValue;
  bool keepaliveHasValueOrDefault = false;
  if (impl.hasKeepalive()) {
    keepaliveValue = v8::Boolean::New(isolate, impl.keepalive());
    keepaliveHasValueOrDefault = true;
  }
  if (keepaliveHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[6].Get(isolate), keepaliveValue))) {
    return false;
  }

  v8::Local<v8::Value> methodValue;
  bool methodHasValueOrDefault = false;
  if (impl.hasMethod()) {
    methodValue = V8String(isolate, impl.method());
    methodHasValueOrDefault = true;
  }
  if (methodHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[7].Get(isolate), methodValue))) {
    return false;
  }

  v8::Local<v8::Value> modeValue;
  bool modeHasValueOrDefault = false;
  if (impl.hasMode()) {
    modeValue = V8String(isolate, impl.mode());
    modeHasValueOrDefault = true;
  }
  if (modeHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[8].Get(isolate), modeValue))) {
    return false;
  }

  v8::Local<v8::Value> redirectValue;
  bool redirectHasValueOrDefault = false;
  if (impl.hasRedirect()) {
    redirectValue = V8String(isolate, impl.redirect());
    redirectHasValueOrDefault = true;
  }
  if (redirectHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[9].Get(isolate), redirectValue))) {
    return false;
  }

  v8::Local<v8::Value> referrerValue;
  bool referrerHasValueOrDefault = false;
  if (impl.hasReferrer()) {
    referrerValue = V8String(isolate, impl.referrer());
    referrerHasValueOrDefault = true;
  }
  if (referrerHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[10].Get(isolate), referrerValue))) {
    return false;
  }

  v8::Local<v8::Value> referrerPolicyValue;
  bool referrerPolicyHasValueOrDefault = false;
  if (impl.hasReferrerPolicy()) {
    referrerPolicyValue = V8String(isolate, impl.referrerPolicy());
    referrerPolicyHasValueOrDefault = true;
  }
  if (referrerPolicyHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[11].Get(isolate), referrerPolicyValue))) {
    return false;
  }

  v8::Local<v8::Value> signalValue;
  bool signalHasValueOrDefault = false;
  if (impl.hasSignal()) {
    signalValue = ToV8(impl.signal(), creationContext, isolate);
    signalHasValueOrDefault = true;
  }
  if (signalHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[12].Get(isolate), signalValue))) {
    return false;
  }

  if (RuntimeEnabledFeatures::PriorityHintsEnabled()) {
    v8::Local<v8::Value> importanceValue;
    bool importanceHasValueOrDefault = false;
    if (impl.hasImportance()) {
      importanceValue = V8String(isolate, impl.importance());
      importanceHasValueOrDefault = true;
    }
    if (importanceHasValueOrDefault &&
        !V8CallBoolean(dictionary->CreateDataProperty(context, keys[4].Get(isolate), importanceValue))) {
      return false;
    }
  }

  return true;
}

RequestInit NativeValueTraits<RequestInit>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  RequestInit impl;
  V8RequestInit::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
