// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "third_party/blink/renderer/bindings/core/v8/v8_window_post_message_options.h"

#include "base/stl_util.h"
#include "third_party/blink/renderer/bindings/core/v8/idl_types.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8WindowPostMessageOptionsKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "targetOrigin",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, base::size(kKeys));
}

void V8WindowPostMessageOptions::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, WindowPostMessageOptions& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8WindowPostMessageOptionsKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> targetOriginValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&targetOriginValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (targetOriginValue.IsEmpty() || targetOriginValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> targetOriginCppValue = NativeValueTraits<IDLUSVString>::NativeValue(isolate, targetOriginValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setTargetOrigin(targetOriginCppValue);
  }
}

v8::Local<v8::Value> WindowPostMessageOptions::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8WindowPostMessageOptions(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8WindowPostMessageOptions(const WindowPostMessageOptions& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8WindowPostMessageOptionsKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> targetOriginValue;
  bool targetOriginHasValueOrDefault = false;
  if (impl.hasTargetOrigin()) {
    targetOriginValue = V8String(isolate, impl.targetOrigin());
    targetOriginHasValueOrDefault = true;
  } else {
    targetOriginValue = V8String(isolate, "/");
    targetOriginHasValueOrDefault = true;
  }
  if (targetOriginHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), targetOriginValue))) {
    return false;
  }

  return true;
}

WindowPostMessageOptions NativeValueTraits<WindowPostMessageOptions>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  WindowPostMessageOptions impl;
  V8WindowPostMessageOptions::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
