// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "third_party/blink/renderer/bindings/modules/v8/v8_address_errors.h"

#include "base/stl_util.h"
#include "third_party/blink/renderer/bindings/core/v8/idl_types.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8AddressErrorsKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "addressLine",
    "city",
    "country",
    "dependentLocality",
    "languageCode",
    "organization",
    "phone",
    "postalCode",
    "recipient",
    "region",
    "regionCode",
    "sortingCode",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, base::size(kKeys));
}

void V8AddressErrors::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, AddressErrors& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8AddressErrorsKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> addressLineValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&addressLineValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (addressLineValue.IsEmpty() || addressLineValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> addressLineCppValue = addressLineValue;
    if (!addressLineCppValue.Prepare(exceptionState))
      return;
    impl.setAddressLine(addressLineCppValue);
  }

  v8::Local<v8::Value> cityValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&cityValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (cityValue.IsEmpty() || cityValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> cityCppValue = cityValue;
    if (!cityCppValue.Prepare(exceptionState))
      return;
    impl.setCity(cityCppValue);
  }

  v8::Local<v8::Value> countryValue;
  if (!v8Object->Get(context, keys[2].Get(isolate)).ToLocal(&countryValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (countryValue.IsEmpty() || countryValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> countryCppValue = countryValue;
    if (!countryCppValue.Prepare(exceptionState))
      return;
    impl.setCountry(countryCppValue);
  }

  v8::Local<v8::Value> dependentLocalityValue;
  if (!v8Object->Get(context, keys[3].Get(isolate)).ToLocal(&dependentLocalityValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (dependentLocalityValue.IsEmpty() || dependentLocalityValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> dependentLocalityCppValue = dependentLocalityValue;
    if (!dependentLocalityCppValue.Prepare(exceptionState))
      return;
    impl.setDependentLocality(dependentLocalityCppValue);
  }

  v8::Local<v8::Value> languageCodeValue;
  if (!v8Object->Get(context, keys[4].Get(isolate)).ToLocal(&languageCodeValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (languageCodeValue.IsEmpty() || languageCodeValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> languageCodeCppValue = languageCodeValue;
    if (!languageCodeCppValue.Prepare(exceptionState))
      return;
    impl.setLanguageCode(languageCodeCppValue);
  }

  v8::Local<v8::Value> organizationValue;
  if (!v8Object->Get(context, keys[5].Get(isolate)).ToLocal(&organizationValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (organizationValue.IsEmpty() || organizationValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> organizationCppValue = organizationValue;
    if (!organizationCppValue.Prepare(exceptionState))
      return;
    impl.setOrganization(organizationCppValue);
  }

  v8::Local<v8::Value> phoneValue;
  if (!v8Object->Get(context, keys[6].Get(isolate)).ToLocal(&phoneValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (phoneValue.IsEmpty() || phoneValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> phoneCppValue = phoneValue;
    if (!phoneCppValue.Prepare(exceptionState))
      return;
    impl.setPhone(phoneCppValue);
  }

  v8::Local<v8::Value> postalCodeValue;
  if (!v8Object->Get(context, keys[7].Get(isolate)).ToLocal(&postalCodeValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (postalCodeValue.IsEmpty() || postalCodeValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> postalCodeCppValue = postalCodeValue;
    if (!postalCodeCppValue.Prepare(exceptionState))
      return;
    impl.setPostalCode(postalCodeCppValue);
  }

  v8::Local<v8::Value> recipientValue;
  if (!v8Object->Get(context, keys[8].Get(isolate)).ToLocal(&recipientValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (recipientValue.IsEmpty() || recipientValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> recipientCppValue = recipientValue;
    if (!recipientCppValue.Prepare(exceptionState))
      return;
    impl.setRecipient(recipientCppValue);
  }

  v8::Local<v8::Value> regionValue;
  if (!v8Object->Get(context, keys[9].Get(isolate)).ToLocal(&regionValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (regionValue.IsEmpty() || regionValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> regionCppValue = regionValue;
    if (!regionCppValue.Prepare(exceptionState))
      return;
    impl.setRegion(regionCppValue);
  }

  v8::Local<v8::Value> regionCodeValue;
  if (!v8Object->Get(context, keys[10].Get(isolate)).ToLocal(&regionCodeValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (regionCodeValue.IsEmpty() || regionCodeValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> regionCodeCppValue = regionCodeValue;
    if (!regionCodeCppValue.Prepare(exceptionState))
      return;
    impl.setRegionCode(regionCodeCppValue);
  }

  v8::Local<v8::Value> sortingCodeValue;
  if (!v8Object->Get(context, keys[11].Get(isolate)).ToLocal(&sortingCodeValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (sortingCodeValue.IsEmpty() || sortingCodeValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> sortingCodeCppValue = sortingCodeValue;
    if (!sortingCodeCppValue.Prepare(exceptionState))
      return;
    impl.setSortingCode(sortingCodeCppValue);
  }
}

v8::Local<v8::Value> AddressErrors::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8AddressErrors(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8AddressErrors(const AddressErrors& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8AddressErrorsKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> addressLineValue;
  bool addressLineHasValueOrDefault = false;
  if (impl.hasAddressLine()) {
    addressLineValue = V8String(isolate, impl.addressLine());
    addressLineHasValueOrDefault = true;
  }
  if (addressLineHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), addressLineValue))) {
    return false;
  }

  v8::Local<v8::Value> cityValue;
  bool cityHasValueOrDefault = false;
  if (impl.hasCity()) {
    cityValue = V8String(isolate, impl.city());
    cityHasValueOrDefault = true;
  }
  if (cityHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), cityValue))) {
    return false;
  }

  v8::Local<v8::Value> countryValue;
  bool countryHasValueOrDefault = false;
  if (impl.hasCountry()) {
    countryValue = V8String(isolate, impl.country());
    countryHasValueOrDefault = true;
  }
  if (countryHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[2].Get(isolate), countryValue))) {
    return false;
  }

  v8::Local<v8::Value> dependentLocalityValue;
  bool dependentLocalityHasValueOrDefault = false;
  if (impl.hasDependentLocality()) {
    dependentLocalityValue = V8String(isolate, impl.dependentLocality());
    dependentLocalityHasValueOrDefault = true;
  }
  if (dependentLocalityHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[3].Get(isolate), dependentLocalityValue))) {
    return false;
  }

  v8::Local<v8::Value> languageCodeValue;
  bool languageCodeHasValueOrDefault = false;
  if (impl.hasLanguageCode()) {
    languageCodeValue = V8String(isolate, impl.languageCode());
    languageCodeHasValueOrDefault = true;
  }
  if (languageCodeHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[4].Get(isolate), languageCodeValue))) {
    return false;
  }

  v8::Local<v8::Value> organizationValue;
  bool organizationHasValueOrDefault = false;
  if (impl.hasOrganization()) {
    organizationValue = V8String(isolate, impl.organization());
    organizationHasValueOrDefault = true;
  }
  if (organizationHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[5].Get(isolate), organizationValue))) {
    return false;
  }

  v8::Local<v8::Value> phoneValue;
  bool phoneHasValueOrDefault = false;
  if (impl.hasPhone()) {
    phoneValue = V8String(isolate, impl.phone());
    phoneHasValueOrDefault = true;
  }
  if (phoneHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[6].Get(isolate), phoneValue))) {
    return false;
  }

  v8::Local<v8::Value> postalCodeValue;
  bool postalCodeHasValueOrDefault = false;
  if (impl.hasPostalCode()) {
    postalCodeValue = V8String(isolate, impl.postalCode());
    postalCodeHasValueOrDefault = true;
  }
  if (postalCodeHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[7].Get(isolate), postalCodeValue))) {
    return false;
  }

  v8::Local<v8::Value> recipientValue;
  bool recipientHasValueOrDefault = false;
  if (impl.hasRecipient()) {
    recipientValue = V8String(isolate, impl.recipient());
    recipientHasValueOrDefault = true;
  }
  if (recipientHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[8].Get(isolate), recipientValue))) {
    return false;
  }

  v8::Local<v8::Value> regionValue;
  bool regionHasValueOrDefault = false;
  if (impl.hasRegion()) {
    regionValue = V8String(isolate, impl.region());
    regionHasValueOrDefault = true;
  }
  if (regionHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[9].Get(isolate), regionValue))) {
    return false;
  }

  v8::Local<v8::Value> regionCodeValue;
  bool regionCodeHasValueOrDefault = false;
  if (impl.hasRegionCode()) {
    regionCodeValue = V8String(isolate, impl.regionCode());
    regionCodeHasValueOrDefault = true;
  }
  if (regionCodeHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[10].Get(isolate), regionCodeValue))) {
    return false;
  }

  v8::Local<v8::Value> sortingCodeValue;
  bool sortingCodeHasValueOrDefault = false;
  if (impl.hasSortingCode()) {
    sortingCodeValue = V8String(isolate, impl.sortingCode());
    sortingCodeHasValueOrDefault = true;
  }
  if (sortingCodeHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[11].Get(isolate), sortingCodeValue))) {
    return false;
  }

  return true;
}

AddressErrors NativeValueTraits<AddressErrors>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  AddressErrors impl;
  V8AddressErrors::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
