// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "third_party/blink/renderer/bindings/modules/v8/v8_payment_validation_errors.h"

#include "base/stl_util.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_address_errors.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_payer_error_fields.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8PaymentValidationErrorsKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "payer",
    "shippingAddress",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, base::size(kKeys));
}

void V8PaymentValidationErrors::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, PaymentValidationErrors& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8PaymentValidationErrorsKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> payerValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&payerValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (payerValue.IsEmpty() || payerValue->IsUndefined()) {
    // Do nothing.
  } else {
    PayerErrorFields payerCppValue;
    V8PayerErrorFields::ToImpl(isolate, payerValue, payerCppValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setPayer(payerCppValue);
  }

  v8::Local<v8::Value> shippingAddressValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&shippingAddressValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (shippingAddressValue.IsEmpty() || shippingAddressValue->IsUndefined()) {
    // Do nothing.
  } else {
    AddressErrors shippingAddressCppValue;
    V8AddressErrors::ToImpl(isolate, shippingAddressValue, shippingAddressCppValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setShippingAddress(shippingAddressCppValue);
  }
}

v8::Local<v8::Value> PaymentValidationErrors::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8PaymentValidationErrors(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8PaymentValidationErrors(const PaymentValidationErrors& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8PaymentValidationErrorsKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> payerValue;
  bool payerHasValueOrDefault = false;
  if (impl.hasPayer()) {
    payerValue = ToV8(impl.payer(), creationContext, isolate);
    payerHasValueOrDefault = true;
  }
  if (payerHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), payerValue))) {
    return false;
  }

  v8::Local<v8::Value> shippingAddressValue;
  bool shippingAddressHasValueOrDefault = false;
  if (impl.hasShippingAddress()) {
    shippingAddressValue = ToV8(impl.shippingAddress(), creationContext, isolate);
    shippingAddressHasValueOrDefault = true;
  }
  if (shippingAddressHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), shippingAddressValue))) {
    return false;
  }

  return true;
}

PaymentValidationErrors NativeValueTraits<PaymentValidationErrors>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  PaymentValidationErrors impl;
  V8PaymentValidationErrors::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
