// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_capabilities.h"

#include "base/stl_util.h"
#include "third_party/blink/renderer/bindings/core/v8/idl_types.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_codec_capability.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_header_extension_capability.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8RTCRtpCapabilitiesKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "codecs",
    "headerExtensions",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, base::size(kKeys));
}

void V8RTCRtpCapabilities::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, RTCRtpCapabilities& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    exceptionState.ThrowTypeError("Missing required member(s): codecs, headerExtensions.");
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8RTCRtpCapabilitiesKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> codecsValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&codecsValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (codecsValue.IsEmpty() || codecsValue->IsUndefined()) {
    exceptionState.ThrowTypeError("required member codecs is undefined.");
    return;
  } else {
    HeapVector<RTCRtpCodecCapability> codecsCppValue = NativeValueTraits<IDLSequence<RTCRtpCodecCapability>>::NativeValue(isolate, codecsValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setCodecs(codecsCppValue);
  }

  v8::Local<v8::Value> headerExtensionsValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&headerExtensionsValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (headerExtensionsValue.IsEmpty() || headerExtensionsValue->IsUndefined()) {
    exceptionState.ThrowTypeError("required member headerExtensions is undefined.");
    return;
  } else {
    HeapVector<RTCRtpHeaderExtensionCapability> headerExtensionsCppValue = NativeValueTraits<IDLSequence<RTCRtpHeaderExtensionCapability>>::NativeValue(isolate, headerExtensionsValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setHeaderExtensions(headerExtensionsCppValue);
  }
}

v8::Local<v8::Value> RTCRtpCapabilities::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8RTCRtpCapabilities(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8RTCRtpCapabilities(const RTCRtpCapabilities& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8RTCRtpCapabilitiesKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> codecsValue;
  bool codecsHasValueOrDefault = false;
  if (impl.hasCodecs()) {
    codecsValue = ToV8(impl.codecs(), creationContext, isolate);
    codecsHasValueOrDefault = true;
  } else {
    NOTREACHED();
  }
  if (codecsHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), codecsValue))) {
    return false;
  }

  v8::Local<v8::Value> headerExtensionsValue;
  bool headerExtensionsHasValueOrDefault = false;
  if (impl.hasHeaderExtensions()) {
    headerExtensionsValue = ToV8(impl.headerExtensions(), creationContext, isolate);
    headerExtensionsHasValueOrDefault = true;
  } else {
    NOTREACHED();
  }
  if (headerExtensionsHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), headerExtensionsValue))) {
    return false;
  }

  return true;
}

RTCRtpCapabilities NativeValueTraits<RTCRtpCapabilities>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  RTCRtpCapabilities impl;
  V8RTCRtpCapabilities::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
