// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_header_extension_parameters.h"

#include "base/stl_util.h"
#include "third_party/blink/renderer/bindings/core/v8/idl_types.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8RTCRtpHeaderExtensionParametersKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "encrypted",
    "id",
    "uri",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, base::size(kKeys));
}

void V8RTCRtpHeaderExtensionParameters::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, RTCRtpHeaderExtensionParameters& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    exceptionState.ThrowTypeError("Missing required member(s): id, uri.");
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8RTCRtpHeaderExtensionParametersKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> encryptedValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&encryptedValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (encryptedValue.IsEmpty() || encryptedValue->IsUndefined()) {
    // Do nothing.
  } else {
    bool encryptedCppValue = NativeValueTraits<IDLBoolean>::NativeValue(isolate, encryptedValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setEncrypted(encryptedCppValue);
  }

  v8::Local<v8::Value> idValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&idValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (idValue.IsEmpty() || idValue->IsUndefined()) {
    exceptionState.ThrowTypeError("required member id is undefined.");
    return;
  } else {
    uint16_t idCppValue = NativeValueTraits<IDLUnsignedShort>::NativeValue(isolate, idValue, exceptionState, kNormalConversion);
    if (exceptionState.HadException())
      return;
    impl.setId(idCppValue);
  }

  v8::Local<v8::Value> uriValue;
  if (!v8Object->Get(context, keys[2].Get(isolate)).ToLocal(&uriValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (uriValue.IsEmpty() || uriValue->IsUndefined()) {
    exceptionState.ThrowTypeError("required member uri is undefined.");
    return;
  } else {
    V8StringResource<> uriCppValue = uriValue;
    if (!uriCppValue.Prepare(exceptionState))
      return;
    impl.setUri(uriCppValue);
  }
}

v8::Local<v8::Value> RTCRtpHeaderExtensionParameters::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8RTCRtpHeaderExtensionParameters(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8RTCRtpHeaderExtensionParameters(const RTCRtpHeaderExtensionParameters& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8RTCRtpHeaderExtensionParametersKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> encryptedValue;
  bool encryptedHasValueOrDefault = false;
  if (impl.hasEncrypted()) {
    encryptedValue = v8::Boolean::New(isolate, impl.encrypted());
    encryptedHasValueOrDefault = true;
  } else {
    encryptedValue = v8::Boolean::New(isolate, false);
    encryptedHasValueOrDefault = true;
  }
  if (encryptedHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), encryptedValue))) {
    return false;
  }

  v8::Local<v8::Value> idValue;
  bool idHasValueOrDefault = false;
  if (impl.hasId()) {
    idValue = v8::Integer::NewFromUnsigned(isolate, impl.id());
    idHasValueOrDefault = true;
  } else {
    NOTREACHED();
  }
  if (idHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), idValue))) {
    return false;
  }

  v8::Local<v8::Value> uriValue;
  bool uriHasValueOrDefault = false;
  if (impl.hasUri()) {
    uriValue = V8String(isolate, impl.uri());
    uriHasValueOrDefault = true;
  } else {
    NOTREACHED();
  }
  if (uriHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[2].Get(isolate), uriValue))) {
    return false;
  }

  return true;
}

RTCRtpHeaderExtensionParameters NativeValueTraits<RTCRtpHeaderExtensionParameters>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  RTCRtpHeaderExtensionParameters impl;
  V8RTCRtpHeaderExtensionParameters::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
