// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/dictionary_v8.cpp.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_transceiver_init.h"

#include "base/stl_util.h"
#include "third_party/blink/renderer/bindings/core/v8/idl_types.h"
#include "third_party/blink/renderer/bindings/core/v8/native_value_traits_impl.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_media_stream.h"
#include "third_party/blink/renderer/bindings/modules/v8/v8_rtc_rtp_encoding_parameters.h"
#include "third_party/blink/renderer/platform/bindings/exception_state.h"

namespace blink {

static const v8::Eternal<v8::Name>* eternalV8RTCRtpTransceiverInitKeys(v8::Isolate* isolate) {
  static const char* const kKeys[] = {
    "direction",
    "sendEncodings",
    "streams",
  };
  return V8PerIsolateData::From(isolate)->FindOrCreateEternalNameCache(
      kKeys, kKeys, base::size(kKeys));
}

void V8RTCRtpTransceiverInit::ToImpl(v8::Isolate* isolate, v8::Local<v8::Value> v8Value, RTCRtpTransceiverInit& impl, ExceptionState& exceptionState) {
  if (IsUndefinedOrNull(v8Value)) {
    return;
  }
  if (!v8Value->IsObject()) {
    exceptionState.ThrowTypeError("cannot convert to dictionary.");
    return;
  }
  v8::Local<v8::Object> v8Object = v8Value.As<v8::Object>();
  ALLOW_UNUSED_LOCAL(v8Object);

  const v8::Eternal<v8::Name>* keys = eternalV8RTCRtpTransceiverInitKeys(isolate);
  v8::TryCatch block(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> directionValue;
  if (!v8Object->Get(context, keys[0].Get(isolate)).ToLocal(&directionValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (directionValue.IsEmpty() || directionValue->IsUndefined()) {
    // Do nothing.
  } else {
    V8StringResource<> directionCppValue = directionValue;
    if (!directionCppValue.Prepare(exceptionState))
      return;
    const char* validValues[] = {
        "sendrecv",
        "sendonly",
        "recvonly",
        "inactive",
    };
    if (!IsValidEnum(directionCppValue, validValues, base::size(validValues), "RTCRtpTransceiverDirection", exceptionState))
      return;
    impl.setDirection(directionCppValue);
  }

  v8::Local<v8::Value> sendEncodingsValue;
  if (!v8Object->Get(context, keys[1].Get(isolate)).ToLocal(&sendEncodingsValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (sendEncodingsValue.IsEmpty() || sendEncodingsValue->IsUndefined()) {
    // Do nothing.
  } else {
    HeapVector<RTCRtpEncodingParameters> sendEncodingsCppValue = NativeValueTraits<IDLSequence<RTCRtpEncodingParameters>>::NativeValue(isolate, sendEncodingsValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setSendEncodings(sendEncodingsCppValue);
  }

  v8::Local<v8::Value> streamsValue;
  if (!v8Object->Get(context, keys[2].Get(isolate)).ToLocal(&streamsValue)) {
    exceptionState.RethrowV8Exception(block.Exception());
    return;
  }
  if (streamsValue.IsEmpty() || streamsValue->IsUndefined()) {
    // Do nothing.
  } else {
    HeapVector<Member<MediaStream>> streamsCppValue = NativeValueTraits<IDLSequence<MediaStream>>::NativeValue(isolate, streamsValue, exceptionState);
    if (exceptionState.HadException())
      return;
    impl.setStreams(streamsCppValue);
  }
}

v8::Local<v8::Value> RTCRtpTransceiverInit::ToV8Impl(v8::Local<v8::Object> creationContext, v8::Isolate* isolate) const {
  v8::Local<v8::Object> v8Object = v8::Object::New(isolate);
  if (!toV8RTCRtpTransceiverInit(*this, v8Object, creationContext, isolate))
    return v8::Undefined(isolate);
  return v8Object;
}

bool toV8RTCRtpTransceiverInit(const RTCRtpTransceiverInit& impl, v8::Local<v8::Object> dictionary, v8::Local<v8::Object> creationContext, v8::Isolate* isolate) {
  const v8::Eternal<v8::Name>* keys = eternalV8RTCRtpTransceiverInitKeys(isolate);
  v8::Local<v8::Context> context = isolate->GetCurrentContext();
  v8::Local<v8::Value> directionValue;
  bool directionHasValueOrDefault = false;
  if (impl.hasDirection()) {
    directionValue = V8String(isolate, impl.direction());
    directionHasValueOrDefault = true;
  } else {
    directionValue = V8String(isolate, "sendrecv");
    directionHasValueOrDefault = true;
  }
  if (directionHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[0].Get(isolate), directionValue))) {
    return false;
  }

  v8::Local<v8::Value> sendEncodingsValue;
  bool sendEncodingsHasValueOrDefault = false;
  if (impl.hasSendEncodings()) {
    sendEncodingsValue = ToV8(impl.sendEncodings(), creationContext, isolate);
    sendEncodingsHasValueOrDefault = true;
  } else {
    sendEncodingsValue = ToV8(HeapVector<RTCRtpEncodingParameters>(), creationContext, isolate);
    sendEncodingsHasValueOrDefault = true;
  }
  if (sendEncodingsHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[1].Get(isolate), sendEncodingsValue))) {
    return false;
  }

  v8::Local<v8::Value> streamsValue;
  bool streamsHasValueOrDefault = false;
  if (impl.hasStreams()) {
    streamsValue = ToV8(impl.streams(), creationContext, isolate);
    streamsHasValueOrDefault = true;
  } else {
    streamsValue = ToV8(HeapVector<Member<MediaStream>>(), creationContext, isolate);
    streamsHasValueOrDefault = true;
  }
  if (streamsHasValueOrDefault &&
      !V8CallBoolean(dictionary->CreateDataProperty(context, keys[2].Get(isolate), streamsValue))) {
    return false;
  }

  return true;
}

RTCRtpTransceiverInit NativeValueTraits<RTCRtpTransceiverInit>::NativeValue(v8::Isolate* isolate, v8::Local<v8::Value> value, ExceptionState& exceptionState) {
  RTCRtpTransceiverInit impl;
  V8RTCRtpTransceiverInit::ToImpl(isolate, value, impl, exceptionState);
  return impl;
}

}  // namespace blink
