// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   core/css/properties/templates/css_property_subclass.h.tmpl
// and input files:
//   ../../3rdparty/chromium/third_party/blink/renderer/core/css/ComputedStyleFieldAliases.json5
//   ../../3rdparty/chromium/third_party/blink/renderer/core/css/CSSProperties.json5
//   ../../3rdparty/chromium/third_party/blink/renderer/core/css/properties/CSSPropertyMethods.json5


#ifndef THIRD_PARTY_BLINK_RENDERER_CORE_CSS_PROPERTIES_LONGHAND_STROKE_H_
#define THIRD_PARTY_BLINK_RENDERER_CORE_CSS_PROPERTIES_LONGHAND_STROKE_H_

#include "third_party/blink/renderer/core/css/css_primitive_value_mappings.h"
#include "third_party/blink/renderer/core/css/css_primitive_value_mappings.h"
#include "third_party/blink/renderer/core/css/css_primitive_value_mappings.h"
#include "third_party/blink/renderer/core/css/properties/longhand.h"
#include "third_party/blink/renderer/core/css/resolver/style_builder_converter.h"
#include "third_party/blink/renderer/core/css/resolver/style_resolver_state.h"
#include "third_party/blink/renderer/core/style/computed_style.h"
#include "third_party/blink/renderer/core/style/svg_computed_style.h"

namespace blink {
namespace CSSLonghand {

// Implements the 'stroke' CSS property
// See src/third_party/WebKit/Source/core/css/properties/README.md
class Stroke final : public Longhand {
 public:
  constexpr Stroke() : Longhand() {}
  const char* GetPropertyName() const override { return "stroke\0"; }
  const WTF::AtomicString& GetPropertyNameAtomicString() const override {
    static const WTF::AtomicString& name = WTF::AtomicString("stroke\0");
    return name;
  }
  const WTF::String GetJSPropertyName() const override {
    return WTF::String("stroke\0");
  }
  CSSPropertyID PropertyID() const override { return CSSPropertyStroke; }
  const CSSValue* ParseSingleValue(CSSParserTokenRange&, const CSSParserContext&, const CSSParserLocalContext&) const override;
  const CSSValue* CSSValueFromComputedStyleInternal(const ComputedStyle&, const SVGComputedStyle&, const LayoutObject*, Node*, bool allow_visited_style) const override;
  bool IsInterpolable() const override { return true; }
  bool IsInherited() const override { return true; }
  bool IsValidForVisitedLink() const override { return true; }

  // Style builder functions
  void ApplyInitial(StyleResolverState& state) const override {
    if (state.ApplyPropertyToRegularStyle())
      state.Style()->AccessSVGStyle().SetStrokePaint(SVGComputedStyle::InitialStrokePaint());
    if (state.ApplyPropertyToVisitedLinkStyle())
      state.Style()->AccessSVGStyle().SetVisitedLinkStrokePaint(SVGComputedStyle::InitialStrokePaint());
  }

  void ApplyInherit(StyleResolverState& state) const override {
    const SVGComputedStyle& parent_svg_style = state.ParentStyle()->SvgStyle();
    if (state.ApplyPropertyToRegularStyle())
      state.Style()->AccessSVGStyle().SetStrokePaint(parent_svg_style.StrokePaint());
    if (state.ApplyPropertyToVisitedLinkStyle())
      state.Style()->AccessSVGStyle().SetVisitedLinkStrokePaint(parent_svg_style.StrokePaint());
  }

  void ApplyValue(StyleResolverState& state, const CSSValue& value) const override {
    SVGPaint paint = StyleBuilderConverter::ConvertSVGPaint(state, value);
    if (state.ApplyPropertyToRegularStyle())
      state.Style()->AccessSVGStyle().SetStrokePaint(paint);
    if (state.ApplyPropertyToVisitedLinkStyle())
      state.Style()->AccessSVGStyle().SetVisitedLinkStrokePaint(paint);
  }
};

}  // namespace CSSLonghand
}  // namespace blink

#endif  // THIRD_PARTY_BLINK_RENDERER_CORE_CSS_PROPERTIES_LONGHAND_STROKE_H_
