// Copyright 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// This file has been auto-generated from the Jinja2 template
// third_party/blink/renderer/bindings/templates/dictionary_impl.h.tmpl
// by the script code_generator_v8.py.
// DO NOT MODIFY!

// clang-format off
#ifndef RTCRtpTransceiverInit_h
#define RTCRtpTransceiverInit_h

#include "third_party/blink/renderer/bindings/core/v8/idl_dictionary_base.h"
#include "third_party/blink/renderer/modules/modules_export.h"
#include "third_party/blink/renderer/modules/peerconnection/rtc_rtp_encoding_parameters.h"
#include "third_party/blink/renderer/platform/heap/handle.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"
#include "third_party/blink/renderer/platform/wtf/vector.h"

namespace blink {

class MediaStream;

class MODULES_EXPORT RTCRtpTransceiverInit : public IDLDictionaryBase {
  DISALLOW_NEW_EXCEPT_PLACEMENT_NEW();
 public:
  RTCRtpTransceiverInit();
  virtual ~RTCRtpTransceiverInit();
  RTCRtpTransceiverInit(const RTCRtpTransceiverInit&);
  RTCRtpTransceiverInit& operator=(const RTCRtpTransceiverInit&);

  bool hasDirection() const { return !direction_.IsNull(); }
  const String& direction() const {
    return direction_;
  }
  inline void setDirection(const String&);

  bool hasSendEncodings() const { return has_send_encodings_; }
  const HeapVector<RTCRtpEncodingParameters>& sendEncodings() const {
    DCHECK(has_send_encodings_);
    return send_encodings_;
  }
  void setSendEncodings(const HeapVector<RTCRtpEncodingParameters>&);

  bool hasStreams() const { return has_streams_; }
  const HeapVector<Member<MediaStream>>& streams() const {
    DCHECK(has_streams_);
    return streams_;
  }
  void setStreams(const HeapVector<Member<MediaStream>>&);

  v8::Local<v8::Value> ToV8Impl(v8::Local<v8::Object>, v8::Isolate*) const override;
  void Trace(blink::Visitor*) override;

 private:
  bool has_send_encodings_ = false;
  bool has_streams_ = false;

  String direction_;
  HeapVector<RTCRtpEncodingParameters> send_encodings_;
  HeapVector<Member<MediaStream>> streams_;

  friend class V8RTCRtpTransceiverInit;
};

void RTCRtpTransceiverInit::setDirection(const String& value) {
  direction_ = value;
}

}  // namespace blink

#endif  // RTCRtpTransceiverInit_h
